#! /usr/stud/paysan/bin/forth
\ Hilbertkurve erzeugen

: copy-left ( to from n -- ) >r swap r> 2/ 0
  ?DO  i' 0  ?DO  over @              over i i' 2* * j + cells + !
                  swap cell+ swap  LOOP  LOOP  2drop ;
: copy-down ( to from n -- ) >r swap r> 2/ 0
  ?DO  i' 0  ?DO  over @  i' dup * +  over i j i' + i' 2* * + cells + !
                  swap cell+ swap  LOOP  LOOP  2drop ;
: copy-mirror ( n to -- )  swap 0
  ?DO  i' 2/ 0 ?DO  dup i cells + @  i' dup * 2* 2* 1- xor
                    over  i' 2* i 1+ - cells + !
               LOOP i' cells +
  LOOP  drop ;

: .hilbert ( addr n -- )  0
  ?DO  cr  i' 0  ?DO  dup @ 4 .r ', emit  cell+  LOOP  LOOP  drop ;

: hilbert ( n -- addr n )  0 1 rot 0
  ?DO  here over dup * cells allot  I 0=
       IF    0 over !
       ELSE  dup 2over copy-left
             dup 2over copy-down
             2dup copy-mirror
       THEN  rot drop swap 2*
  LOOP  2/ ;

: hilbert' ( addr n -- addr' n )
  >r here r@ dup * cells allot swap  r@ dup * 0
  ?DO  2dup @ cells + I swap !  cell+  LOOP  r>  nip ;

script? [IF]  0. 2 arg >number 2drop drop hilbert hilbert' .hilbert bye [THEN]
